
REM     Program: BAS_DEMO.BAS
REM
REM     CONFIGURE COM2 OF PC
REM
REM     BAUD RATE : 9600
REM     PARITY    : None
REM     DATA BITS : 8
REM     STOP BIT  : 1
REM

REM
REM     Look-up table for converting each digit
REM
        DIM DIGIT$(16)
        DIGIT$(0) = "0": DIGIT$(1) = "8": DIGIT$(2) = "4"
        DIGIT$(4) = "2": DIGIT$(6) = "6": DIGIT$(8) = "1"
        DIGIT$(9) = "9": DIGIT$(10) = "5": DIGIT$(12) = "3"
        DIGIT$(14) = "7"

        CLS
        LOCATE 2, 1
        PRINT "           *********************************************************"
        PRINT "           *                                                       *"
        PRINT "           *       DEMO PROGRAM using QBASIC/QUICK BASIC           *"
        PRINT "           *                                                       *"
        PRINT "           *   1. To communicate, press any key except 9,4,2,1,    *"
        PRINT "           *      E and e.                                         *"
        PRINT "           *   2. To end, press ESC.                               *"
        PRINT "           *                                                       *"
        PRINT "           *********************************************************"

REM
REM     Initialize com port
REM

REIN:   LOCATE 14, 15
        INPUT "Which com port to use ? COM1=1,COM2=2"; PORT$
        IF (PORT$ <> "1") AND (PORT$ <> "2") THEN GOTO REIN
        COMNUM = VAL(PORT$)
        COM$ = "COM" + PORT$ + ": 9600,N,8,1,CS,DS,CD,RS,TB256,RB256"
        OPEN COM$ FOR RANDOM AS #1
        LOCATE 14, 15
        PRINT "                                                       "

REM
REM     Screen layout for function key
REM
        COLOR 0, 7
        LOCATE 24, 3, 0
        PRINT " F1 = File name :                    ";
        LOCATE 24, 42
        PRINT " F2 = Start ";
        LOCATE 24, 56
        PRINT " F3 = Stop ";
        LOCATE 25, 3
        PRINT " F4 = Sample time ( 0     sec ) ( 1 TO 86400 sec, 0 FOR MANUL) ";
        LOCATE 24, 69
        PRINT " ESC = Exit ";
        LOCATE 19, 30
        PRINT " STOP  "
        LOCATE 19, 39
        PRINT " MANUAL "
        COLOR 7, 0
        START = 0
        SAMPLE = 0
        RECORD = 0
        FIRST$ = "Y"

REM
REM     Get the key pressed by user and display the ASCII
REM     code in hex format on screen .
REM     Scan code CHR$(59) = F1
REM               CHR$(60) = F2
REM               CHR$(61) = F3
REM               CHR$(62) = F4
REM               CHR$(27) = ESC
REM

GETKEY:
           DO
           A$ = INKEY$
           LOOP WHILE (A$ = "")
           LOCATE 20, 15
           PRINT "                                                           "
NOTGET:
           IF FIRST$ = "Y" THEN
             GOSUB READM
           END IF

REM     If ESC pressed,  program ends .
REM
        IF A$ = CHR$(27) THEN
           CLOSE #1
           CLOSE #2
           CLS
           END
        END IF

REM     If function keys pressed  the scan code has 2 bytes .
REM
        IF LEN(A$) = 2 THEN
           LOCATE 18, 20
           SELECT CASE RIGHT$(A$, 1)
                ' F1
                CASE CHR$(59): LOCATE 20, 20
                               COLOR 0, 7
                               TIMER OFF
                               PRINT "INPUT FILENAME                 "
                               LOCATE 20, 35
                               INPUT ": ", NAME$
                               IF RECORD = 1 THEN
                                    CLOSE #2
                               END IF
                               LOCATE 24, 21
                               PRINT "             ";
                               IF NAME$ = "" THEN
                                 RECORD = 0
                                 CLOSE #2
                                 COLOR 7, 0
                                 LOCATE 20, 20
                                 PRINT "                                     "
                                 IF SAMPLE = 1 THEN
                                   GOTO ENDSELECT
                                 ELSE
                                  GOTO GETKEY
                                 END IF
                               END IF

                               OPEN NAME$ FOR OUTPUT AS #2
                               LOCATE 24, 21
                               PRINT NAME$;
                               COLOR 7, 0
                               LOCATE 20, 20
                               PRINT "                                      "
                               RECORD = 1
                               TIMER ON
                ' F2
                CASE CHR$(60): LOCATE 19, 30
                               COLOR 0, 7
                               PRINT " START "
                               COLOR 7, 0
                               START = 1
                               TIMER ON

                ' F3
                CASE CHR$(61): LOCATE 19, 30
                               COLOR 0, 7
                               PRINT " STOP  "
                               COLOR 7, 0
                               START = 0
                               TIMER OFF
                'F4
                CASE CHR$(62): COLOR 0, 7
RETRY:                         LOCATE 20, 20
                               PRINT "INPUT SAMPLE TIME              "
                               LOCATE 20, 39
                               INPUT ": ", STIME
                               STIME = INT(STIME)
                               IF STIME > 86400 OR STIME < 0 THEN GOTO RETRY
                               LOCATE 25, 22
                               PRINT "      ";
                               LOCATE 25, 22
                               PRINT STIME;
                               COLOR 7, 0
                               LOCATE 20, 20
                               PRINT "                                       "
                               IF STIME = 0 THEN
                                   TIMER OFF
                                   COLOR 0, 7
                                   LOCATE 19, 39
                                   PRINT " MANUAL "
                                   COLOR 7, 0
                                   SAMPLE = 0
                               ELSE
                                   COLOR 0, 7
                                   LOCATE 19, 39
                                   PRINT " AUTO  "
                                   COLOR 7, 0
                                   SAMPLE = 1
                                   LOCATE 12, 15
                                   PRINT "                                "
                                   IF START = 1 THEN
                                     A$ = CHR$(32) + CHR$(60)
                                     GOTO NOTGET
                                   ELSE
                                     A$ = " "
                                   END IF
                               END IF
           END SELECT
ENDSELECT:
           IF (SAMPLE = 1) AND (START = 1) THEN
                ON TIMER(INT(STIME)) GOSUB GETCOM
           END IF
           GOTO GETKEY
        END IF
        IF START = 0 THEN GOTO GETKEY
        IF SAMPLE = 0 THEN
           LOCATE 12, 15
           PRINT "CODE SENT OUT IS :"; HEX$(ASC(A$))
           GOSUB GETCOM
        END IF
        GOTO GETKEY

REM
REM     Receive 5 bytes from multimeter through serial port (COM1)
REM



GETCOM:

REM     Close COM port first to avoid any unwanted data left in the
REM     serial port buffer .

        IF RECORD = 1 THEN
            CLOSE #2
            OPEN NAME$ FOR APPEND AS #2
        END IF
        CLOSE #1
        OPEN COM$ FOR RANDOM AS #1
        PRINT #1, A$
REM        B$ = INPUT$(5, #1)
     B$ = ""
     C$ = ""
     RECEIVECODE$ = ""
     FOR I = 1 TO 1000
     IF NOT EOF(1) THEN
         FOR M = 1 TO LOC(1)
           C$ = INPUT$(1, #1)
           B$ = B$ + C$
           RECEIVECODE$ = RECEIVECODE$ + RIGHT$("0" + HEX$(ASC(C$)), 2)
         NEXT M
     END IF
     NEXT I
     LOCATE 12, 37
     IF TESMODEL$ = "2732" OR TESMODEL$ = "1352" THEN
      RECEIVECODE$ = LEFT$(RECEIVECODE$, 12)
     ELSE
      RECEIVECODE$ = LEFT$(RECEIVECODE$, 14)
    END IF
     PRINT "CODE RECEIVED IS :"; RECEIVECODE$

     IF B$ = "" THEN
       LOCATE 20, 15
       PRINT "COMM ERROR !!!! PRESS ANYKEY TO CONTINUE OR ESC TO QUIT"
       SOUND 1174.7, 5
       SOUND 1046.5, 5
       LOCATE 20, 15
       IF SAMPLE = 1 THEN
           DO
           HA$ = INKEY$
           LOOP WHILE (HA$ = "")
        IF HA$ = CHR$(27) THEN
           CLOSE #1
           CLOSE #2
           CLS
           END
        END IF

        LOCATE 20, 15
        PRINT "                                                            "
        GOTO GETCOM
      END IF
       GOTO GETKEY
     END IF





REM
REM     If want to display 5 bytes data received ,use the following
REM     program code .
REM
REM        LOCATE 16, 20
REM        FOR I = 1 TO 5
REM             A$ = MID$(B$, I, 1)
REM             PRINT HEX$(ASC(A$)) + "   ";
REM        NEXT I

REM
REM     Decode second byte ( Function and range )
REM
       IF TESMODEL$ = "1352" THEN
         GOTO M1352
       ELSE
        IF TESMODEL$ = "3060" THEN
          GOTO M3060
        END IF
       END IF
M2732:

        FUNCTION$ = ""
        RANGE$ = ""
REM          PRINT B$
        SELECT CASE ASC(MID$(B$, 2, 1))
           CASE 0: FUNCTION$ = "DCV": RANGE$ = "200mV"
           CASE 1: FUNCTION$ = "DCV": RANGE$ = "2V"
           CASE 2: FUNCTION$ = "DCV": RANGE$ = "20V"
           CASE 3: FUNCTION$ = "DCV": RANGE$ = "200V"
           CASE 4: FUNCTION$ = "DCV": RANGE$ = "1000V"

           CASE 5: FUNCTION$ = "FREQ": RANGE$ = "KHz"

           CASE 6: FUNCTION$ = "DIODE": RANGE$ = ""

           CASE 8: FUNCTION$ = "RES": RANGE$ = "200 Ohm"
           CASE 9: FUNCTION$ = "RES": RANGE$ = "2K Ohm"
           CASE 10: FUNCTION$ = "RES": RANGE$ = "20K Ohm"
           CASE 12: FUNCTION$ = "RES": RANGE$ = "200K Ohm"
           CASE 16: FUNCTION$ = "RES": RANGE$ = "2M Ohm"
           CASE 17: FUNCTION$ = "RES": RANGE$ = "20M Ohm"

           CASE 18: FUNCTION$ = "CAP": RANGE$ = "20 uF"
           CASE 20: FUNCTION$ = "CAP": RANGE$ = "2 uF"
           CASE 24: FUNCTION$ = "CAP": RANGE$ = "200 nF"
           CASE 32: FUNCTION$ = "CAP": RANGE$ = "2000 pF"

           CASE 33: FUNCTION$ = "DCA": RANGE$ = "20 A"
           CASE 34: FUNCTION$ = "DCA": RANGE$ = "200 mA"
           CASE 36: FUNCTION$ = "DCA": RANGE$ = "20 mA"
           CASE 40: FUNCTION$ = "DCA": RANGE$ = "2 mA"
           CASE 48: FUNCTION$ = "DCA": RANGE$ = "200 uA"

           CASE 64: FUNCTION$ = "TEMP": RANGE$ = "200 F"
           CASE 65: FUNCTION$ = "TEMP": RANGE$ = "2000 F"
           CASE 66: FUNCTION$ = "TEMP": RANGE$ = "200 C"
           CASE 68: FUNCTION$ = "TEMP": RANGE$ = "2000 C"

           CASE 128: FUNCTION$ = "ACV": RANGE$ = "200 mV"
           CASE 129: FUNCTION$ = "ACV": RANGE$ = "2 V"
           CASE 130: FUNCTION$ = "ACV": RANGE$ = "20 V"
           CASE 131: FUNCTION$ = "ACV": RANGE$ = "200 V"
           CASE 132: FUNCTION$ = "ACV": RANGE$ = "750 V"

           CASE 161: FUNCTION$ = "ACA": RANGE$ = "20 A"
           CASE 162: FUNCTION$ = "ACA": RANGE$ = "200 mA"
           CASE 164: FUNCTION$ = "ACA": RANGE$ = "20 mA"
           CASE 168: FUNCTION$ = "ACA": RANGE$ = "2 mA"
           CASE 176: FUNCTION$ = "ACA": RANGE$ = "200 uA"
           CASE 255: FUNCTION$ = "WARNING ----HOLD"
        END SELECT

        LOCATE 14, 15
        PRINT "TIME:"; TIME$
        LOCATE 16, 15
        PRINT "                         "
        LOCATE 16, 15
        PRINT FUNCTION$ + "     " + RANGE$
        IF RECORD = 1 THEN
            PRINT #2, TIME$ + ",", FUNCTION$ + ",", RANGE$ + ",",
        END IF
        LOCATE 16, 32
        PRINT ":                                   "

REM
REM     Get the third and fourth bytes only ( Multimeter's reading )
REM
        V& = ASC(MID$(B$, 4, 1))
        V& = V& * 256
        V& = V& + ASC(MID$(B$, 3, 1))

REM
REM     Check overload and initial state embedded in byte 3
REM     Get the last 6 bits
REM
        STATE = V& MOD 64
REM     Initial state
        IF STATE = 64 THEN GOTO GETCOM
REM     Positive overload
        IF STATE = 15 THEN
            LOCATE 16, 34
            PRINT "    OL"
            IF RECORD = 1 THEN
                PRINT #2, "    OL"
            END IF
            RETURN
        END IF
REM     Negative overload
        IF STATE = 14 THEN
            LOCATE 16, 34
            PRINT "   -OL"
            IF RECORD = 1 THEN
                PRINT #2, "   -OL"
            END IF
            RETURN
        END IF
        IF ASC(LEFT$(B$, 1)) <> 2 OR ASC(RIGHT$(B$, 1)) <> 3 THEN
            LOCATE 16, 34
            PRINT "RECEIVE DATA ERROR, PLEASE RETRY!"
            IF RECORD = 1 THEN
                PRINT #2, "RECEIVE DATA ERROR, PLEASE RETRY!"
            END IF
            RETURN
        END IF

REM
REM     Decode polarity ,KHz or MHz
REM
        IF FUNCTION$ = "FREQ" THEN
            IF V& AND 1 THEN
                RANGE$ = "MHz":
                VA$ = " "
            END IF
        ELSE
            IF V& AND 1 THEN
                VA$ = " "
            ELSE
                VA$ = "-"
            END IF
        END IF
        IF V& AND 2 THEN
            VA$ = VA$ + "1"
        ELSE
            VA$ = VA$ + " "
        END IF

REM
REM     4th and 3rd byte assemble a word,
REM     bit 2 to 5 : the second digit
REM     bit 6 to 9 : the third digit
REM     bit 10 to 13 : the least significant digit
REM
REM     Shift right 4 bits by dividing it by 16 .
REM     Get the last 4 bits by moding it by 16 .
REM
        DIGIT1 = (V& \ 4) MOD 16
        VA$ = VA$ + DIGIT$(DIGIT1)
        DIGIT2 = (V& \ 64) MOD 16
        VA$ = VA$ + DIGIT$(DIGIT2)
        DIGIT3 = (V& \ 1024) MOD 16
        VA$ = VA$ + DIGIT$(DIGIT3)

REM
REM     Decimal point position :
REM     DPRINT = 0      none
REM              2      dp1, right most position
REM              1      dp2
REM              3      dp3
REM

        DPOINT = 0
        SELECT CASE V& \ 1024 \ 16
            CASE 2: VA$ = LEFT$(VA$, 4) + "." + RIGHT$(VA$, 1): DPOINT = 1
            CASE 1: VA$ = LEFT$(VA$, 3) + "." + RIGHT$(VA$, 2): DPOINT = 2
            CASE 3: VA$ = LEFT$(VA$, 2) + "." + RIGHT$(VA$, 3): DPOINT = 3
        END SELECT
        LOCATE 16, 34
        PRINT VA$
        IF RECORD = 1 THEN
            PRINT #2, VA$
        END IF
        RETURN
M1352:
        FUNCTION$ = ""
        RANGE$ = ""
        SELECT CASE ASC(MID$(B$, 2, 1))
           CASE 96: FUNCTION$ = "dB": RANGE$ = "30-80"
           CASE 97: FUNCTION$ = "dB": RANGE$ = "40-90"
           CASE 98: FUNCTION$ = "dB": RANGE$ = "50-100"
           CASE 99: FUNCTION$ = "dB": RANGE$ = "60-110"
           CASE 100: FUNCTION$ = "dB": RANGE$ = "70-120"
           CASE 101: FUNCTION$ = "dB": RANGE$ = "80-130"
           CASE 102: FUNCTION$ = "dB": RANGE$ = "30-130"
           CASE 255: FUNCTION$ = "WARNING ----HOLD"
        END SELECT
REM
REM     Decode 1352 Status
REM
        STATUSBYTE% = ASC(MID$(B$, 5, 1))
        IF (STATUSBYTE% AND 16) = 0 THEN
           FUNCTION$ = FUNCTION$ + "A"
        ELSE
           FUNCTION$ = FUNCTION$ + "C"
        END IF
        STATUS1352$ = ""
        IF (STATUSBYTE% AND 2) = 0 THEN
           STATUS1352$ = STATUS1352$ + "Slow "
        ELSE
           STATUS1352$ = STATUS1352$ + "Fast "
        END IF
        IF (STATUSBYTE% AND 4) = 0 THEN
           STATUS1352$ = STATUS1352$ + "Normal "
        ELSE
           STATUS1352$ = STATUS1352$ + "MAX "
        END IF
        IF (STATUSBYTE% AND 8) <> 0 THEN
           STATUS1352$ = STATUS1352$ + "Low Batt"
        END IF
        LOCATE 14, 15
        PRINT "Time: "; TIME$
        LOCATE 16, 15
        PRINT "                         "
        LOCATE 16, 15
        PRINT FUNCTION$ + "     " + RANGE$
        IF RECORD = 1 THEN
            PRINT #2, TIME$ + ",", FUNCTION$ + ",", RANGE$ + ",",
        END IF
        LOCATE 16, 32
        PRINT ":                                   "

REM
REM     Get the third and fourth bytes only ( Multimeter's reading )
REM
        V& = ASC(MID$(B$, 4, 1))
        V& = V& * 256
        V& = V& + ASC(MID$(B$, 3, 1))

REM
REM     Check overload and initial state embedded in byte 3
REM     Get the last 6 bits
REM
        STATE = V& MOD 64
REM     Initial state
        IF STATE = 64 THEN GOTO GETCOM
REM     Positive overload
        IF STATE = 15 THEN
            LOCATE 16, 34
            PRINT "    OL"
            IF RECORD = 1 THEN
                PRINT #2, "    OL"
            END IF
            RETURN
        END IF
REM     Negative overload
        IF STATE = 14 THEN
            LOCATE 16, 34
            PRINT "   -OL"
            IF RECORD = 1 THEN
                PRINT #2, "   -OL"
            END IF
            RETURN
        END IF
        IF ASC(LEFT$(B$, 1)) <> 2 OR ASC(RIGHT$(B$, 1)) <> 3 THEN
            LOCATE 16, 34
            PRINT "RECEIVE DATA ERROR, PLEASE RETRY!"
            IF RECORD = 1 THEN
                PRINT #2, "RECEIVE DATA ERROR, PLEASE RETRY!"
            END IF
            RETURN
        END IF

REM
REM     Decode polarity
REM
        IF V& AND 1 THEN
                VA$ = " "
        ELSE
                VA$ = "-"
        END IF
REM
REM     Decode Most Significant Digit
REM
        IF V& AND 2 THEN
            VA$ = VA$ + "1"
        ELSE
            VA$ = VA$ + " "
        END IF

REM
REM     4th and 3rd byte assemble a word,
REM     bit 2 to 5 : the second digit
REM     bit 6 to 9 : the third digit
REM     bit 10 to 13 : the least significant digit
REM
REM     Shift right 4 bits by dividing it by 16 .
REM     Get the last 4 bits by moding it by 16 .
REM
        DIGIT1 = (V& \ 4) MOD 16
        VA$ = VA$ + DIGIT$(DIGIT1)
        DIGIT2 = (V& \ 64) MOD 16
        VA$ = VA$ + DIGIT$(DIGIT2)
        DIGIT3 = (V& \ 1024) MOD 16
        VA$ = VA$ + DIGIT$(DIGIT3)

REM
REM     Decimal point position :
REM     DPRINT = 0      none
REM              2      dp1, right most position
REM              1      dp2
REM              3      dp3
REM

        DPOINT = 0
        SELECT CASE V& \ 1024 \ 16
            CASE 2: VA$ = LEFT$(VA$, 4) + "." + RIGHT$(VA$, 1): DPOINT = 1
            CASE 1: VA$ = LEFT$(VA$, 3) + "." + RIGHT$(VA$, 2): DPOINT = 2
            CASE 3: VA$ = LEFT$(VA$, 2) + "." + RIGHT$(VA$, 3): DPOINT = 3
        END SELECT
        LOCATE 16, 34
        PRINT VA$
        IF RECORD = 1 THEN
            PRINT #2, VA$ + ",", STATUS1352$
        END IF
        LOCATE 16, 48
        PRINT STATUS1352$
        RETURN
M3060:

        FUNCTION$ = ""
        RANGE$ = ""
REM          PRINT B$
    SELECT CASE ASC(MID$(B$, 2, 1))
       CASE 208: FUNCTION$ = "PF"
            meterLow! = -1
            meterMax! = 1
            unit$ = "Pf"
            pwrmeter.piccos.Visible = True
       CASE 209: FUNCTION$ = "Watt"
            meterLow! = -1000
            meterMax! = 1000
            unit$ = " KW"
       CASE 210: FUNCTION$ = "Watt"
            meterLow! = 0
            meterMax! = 1000
            unit$ = "KVA"
       CASE 211: FUNCTION$ = "DC"
            meterLow! = -1000
            meterMax! = 1000
            unit$ = " A "
       CASE 212: FUNCTION$ = "AC"
            meterLow! = 0
            meterMax! = 1000
            unit$ = " A "
       CASE 213: FUNCTION$ = "A-Freq"
            unit$ = " Hz"
            meterLow! = 0
            meterMax! = 1000
       CASE 214: FUNCTION$ = "A-Freq"
            unit$ = "KHz"
            meterLow! = 0
            meterMax! = 1000
       CASE 215: FUNCTION$ = "DC"
            unit$ = " V "
            meterLow! = -1000
            meterMax! = 1000
       CASE 216: FUNCTION$ = "AC"
            unit$ = " V "
            meterLow! = 0
            meterMax! = 750
       CASE 217: FUNCTION$ = "V-Freq"
            unit$ = " Hz"
            meterLow! = 0
            meterMax! = 1000
       CASE 218: FUNCTION$ = "V-Freq"
            unit$ = "KHz"
            meterLow! = 0
            meterMax! = 1000
       CASE 219: FUNCTION$ = "Ohm"
            pwrmeter.picohm.Visible = True
            unit$ = "Kohm"
            meterLow! = 0
            meterMax! = 10
       CASE 220: FUNCTION$ = "Cont."
            pwrmeter.picohm.Visible = True
            unit$ = ""
            meterLow! = 0
            meterMax! = 1000
       CASE 221: FUNCTION$ = "DIODE"
            unit$ = " V "
            meterLow! = 0
            meterMax! = 10
       CASE ELSE
            temp$ = ""
            meterLow! = 0
            meterMax! = 0
    END SELECT

        LOCATE 14, 15
        PRINT "TIME:"; TIME$
        LOCATE 16, 15
        PRINT "                         "
        LOCATE 16, 15
        PRINT FUNCTION$

        LOCATE 16, 32
        PRINT ":                                   "
       F$ = ""
       G$ = ""




REM
REM     Get the fourth and five bytes only ( Multimeter's reading )
REM
        DIG12$ = RIGHT$("0" + HEX$(ASC(MID$(B$, 4, 1))), 2)
        DIG34$ = RIGHT$("0" + HEX$(ASC(MID$(B$, 5, 1))), 2)
        BYTE3& = ASC(MID$(B$, 3, 1)) \ 16
        BIT12& = BYTE3& \ 4
        BIT34& = BYTE3& MOD 4

REM
REM     Check overload and initial state embedded in byte 3
REM     Get the last 6 bits
REM
REM     Positive overload

        BYTE3& = ASC(MID$(B$, 3, 1)) \ 16
        BIT12& = BYTE3& \ 4
        BIT34& = BYTE3& MOD 4
        IF BIT12& = 1 THEN
            LOCATE 16, 34
            PRINT "    OL"
            IF RECORD = 1 THEN
                PRINT #2, "    OL"
            END IF
            RETURN
        END IF
REM     Negative overload
        IF BIT12& = 3 THEN
            LOCATE 16, 34
            PRINT "   -OL"
            IF RECORD = 1 THEN
                PRINT #2, "   -OL"
            END IF
            RETURN
        END IF
        IF ASC(LEFT$(B$, 1)) <> 2 OR ASC(RIGHT$(B$, 1)) <> 3 THEN
            LOCATE 16, 34
            PRINT "RECEIVE DATA ERROR, PLEASE RETRY!"
            IF RECORD = 1 THEN
                PRINT #2, "RECEIVE DATA ERROR, PLEASE RETRY!"
            END IF
            RETURN
        END IF


        VSI& = BIT12& \ 2
        DPOINT = 0
        SELECT CASE BIT34&
            CASE 0: VA$ = DIG12$ + LEFT$(DIG34$, 1) + "." + RIGHT$(DIG34$, 1): DPOINT = 1
            CASE 1: VA$ = DIG12$ + "." + DIG34$: DPOINT = 1
            CASE 2: VA$ = LEFT$(DIG12$, 1) + "." + RIGHT$(DIG12$, 1) + DIG34$: DPOINT = 1
        END SELECT
        IF VSI& = 1 THEN VA$ = "-" + VA$
        LOCATE 16, 34
        PRINT VA$ + " " + unit$
        DATESTR$ = LEFT$(DATE$, 6) + RIGHT$(DATE$, 2)
        IF RECORD = 1 THEN
            PRINT #2, DATESTR$ + CHR$(9) + TIME$ + CHR$(9) + FUNCTION$ + CHR$(9) + VA$ + CHR$(9) + unit$
        END IF
        RETURN


READM:
        CLOSE #1
        OPEN COM$ FOR RANDOM AS #1
        PRINT #1, "M"
        FOR I = 1 TO 500
        NEXT I
     D$ = ""
     E$ = ""
     FOR I = 1 TO 1000
     IF NOT EOF(1) THEN
         FOR M = 1 TO LOC(1)
           D$ = INPUT$(1, #1)
           E$ = E$ + RIGHT$(("0" + HEX$(ASC(D$))), 2)
         NEXT M
     END IF
     NEXT I
  IF E$ <> "" THEN
  FIRST$ = "N"
  TESMODEL$ = MID$(E$, 3, 4)
  IF TESMODEL$ <> "1352" AND TESMODEL$ <> "3060" THEN
   TESMODEL$ = "2732"
  END IF
  LOCATE 10, 30
  PRINT "MODEL: " + TESMODEL$
  END IF

RETURN

